using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.Xml;
using System.Data.OleDb;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;
using Syncfusion.Grouping;

namespace TemplatedCheckboxInCode
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected Syncfusion.Web.UI.WebControls.Grid.Grouping.GridGroupingControl GridGroupingControl1;
		private OleDbConnection oledbConnection;
		private OleDbDataAdapter oledbAdapter1;
		private DataSet dsDataset1 = new DataSet();
		private OleDbCommand oledbCommand1 = new OleDbCommand();
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Label lblInfo;
		protected System.Web.UI.WebControls.Label Label2;
		private string strConnection;

		private void Page_Load(object sender, System.EventArgs e)
		{
		

		}
		public void BindGrid()
		{
			string selectCommand;

			//Specifies connection information to the OleDbConnection.
			strConnection = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + MapPath("\\Syncfusion\\Web\\Data\\nwind.mdb"); 
			selectCommand = "SELECT CategoryID,CategoryName,Description FROM Categories";
			oledbConnection = new OleDbConnection(strConnection);
			oledbAdapter1 = new OleDbDataAdapter(selectCommand, oledbConnection);
  
			//Open the connection to the database.
			oledbConnection.Open();
  
			//Filing the records from the database to dataset. 
			oledbAdapter1.Fill(dsDataset1, "Categories");
  
			//Connect the Grid to the datasource using Datasource property.
			this.GridGroupingControl1.DataSource = dsDataset1;
			this.GridGroupingControl1.DataMember = "Categories";
		}


		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.GridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Web.UI.WebControls.Grid.Grouping.GridTableCellStyleInfoEventHandler(this.GridGroupingControl1_QueryCellStyleInfo);
			this.Load += new System.EventHandler(this.Page_Load);
			this.Init += new System.EventHandler(this.WebForm1_Init);

		}
		#endregion

		private void WebForm1_Init(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			BindGrid();
			GridTableDescriptor maintd = this.GridGroupingControl1.TableDescriptor;
			maintd.PrimaryKeyColumns.Add("CategoryID");
			this.GridGroupingControl1.DataBind();
			oledbConnection.Close();
			this.GridGroupingControl1.TableDescriptor.UnboundFields.Add("UnboundColumn");
			this.GridGroupingControl1.TableDescriptor.Columns.Add("UnboundColumn");
			this.GridGroupingControl1.TableDescriptor.VisibleColumns.Add("UnboundColumn");

			//Declare the "UnBoundColumn as a templated column here.
			
			// you can also use any control here, this is just for defining only see 'QueryCellStyleInfo' event where we define the template as a checkbox
			Control ctrl=new Control();// also possible here://CheckBox chkBox=new CheckBox();
			//see the TemplateClass.
			TemplateClass tc=new TemplateClass(ctrl);
			this.GridGroupingControl1.TableDescriptor.Columns.FindByMappingName("UnboundColumn").ItemTemplate=tc;		
		}

		//QueryCellStyleInfo event triggers for each cell in the grid grouping control.
		private void GridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Web.UI.WebControls.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
		{
			//Check for the RecordFieldCell
			if (e.TableCellIdentity.TableCellType == GridTableCellType.AlternateRecordFieldCell || e.TableCellIdentity.TableCellType == GridTableCellType.RecordFieldCell)
			{
				//Apply the checkbox for the 'UNBOUNDCOLUMN'
				if(e.TableCellIdentity.Column.MappingName=="UnboundColumn")
				{
					CheckBox chkBox=new CheckBox();
					//Handle the checkbox CheckedChanged event.
					chkBox.CheckedChanged +=new EventHandler(chkBox_CheckedChanged);
					//if you need the checkbox to trigger a post back on each checked changed event.
					//chkBox.AutoPostBack=true;
					TemplateClass tc=new TemplateClass(chkBox);
					this.GridGroupingControl1.TableDescriptor.Columns.FindByMappingName("UnboundColumn").ItemTemplate=tc;
				}
				
			}
		}
		// This will trigger  whenever there is a checked state cange in the cehckbox.
		private void chkBox_CheckedChanged(object sender, EventArgs e)
		{
			CheckBox chkbox1=(CheckBox)sender;
			//getting the row of which the checkbox is toggled.
			GridRow gridrow=(GridRow)chkbox1.Parent.Parent;
			//retreiving the 'CategoryID' field from the row.
            string catID=gridrow.Record.GetValue("CategoryID").ToString();
			if(chkbox1 !=null)
			{
				if(chkbox1.Checked==true)
				{
					this.lblInfo.Text= this.lblInfo.Text + "Selected Category-<B>" + catID + "</B><br>";
				}
				else
				{
					this.lblInfo.Text=this.lblInfo.Text + "Un Selected Category-<B>" + catID + "</B><br>";
				}
			}
			

		}
	}
	
	//We use this template class for adding templates through code 
	public class TemplateClass: ITemplate
	{
		private Control m_ctrlChildControl = null;
		public TemplateClass(Control ctrlChildControl)
		{
			m_ctrlChildControl = ctrlChildControl;
		}

		public void InstantiateIn(Control container)
		{
			container.Controls.Add(m_ctrlChildControl);
		}
	}
}
